#version 330 core

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec2 fragmentUV;
out vec3 fragmentNormal;
out vec3 worldPos;
out vec4 lightSpacePos;

uniform mat4 model;
uniform mat4 view_proj;
uniform mat4 view;
uniform mat4 light_view_proj;



//Animation---------------------
uniform bool animate;
uniform mat4 boneMatrices[60];

in vec4 inBoneWeights;
in vec4 inBoneIndices;
//------------------------------

void main()
{
	fragmentUV = uv;
	if(animate){
		vec4 boneWeights = inBoneWeights;
		boneWeights = boneWeights / (boneWeights.x + boneWeights.y + boneWeights.z + boneWeights.w);

		mat4 trafo = boneWeights.x * boneMatrices[int(inBoneIndices.x)] + boneWeights.y * boneMatrices[int(inBoneIndices.y)] + boneWeights.z * boneMatrices[int(inBoneIndices.z)] +					 boneWeights.w * boneMatrices[int(inBoneIndices.w)];
		//mat4 trafo = mat4(1);

		worldPos = (model * trafo * vec4(position, 1)).xyz;
		fragmentNormal = normalize((model * trafo * vec4(normal, 0)).xyz);		
		gl_Position = view_proj * model *  trafo * vec4(position, 1);
		lightSpacePos = light_view_proj * model *  trafo * vec4(position, 1);
	}else{
		gl_Position = view_proj * model * vec4(position, 1);
		lightSpacePos = light_view_proj * model *  vec4(position, 1);
		fragmentNormal = (model * vec4(normal, 0.0)).xyz;
		worldPos = (model * vec4(position, 1.0)).xyz;
	}
}